﻿#line 1 "CDATASection.upp"
#include <ccc/xml/dom.h>

using namespace CCC;

// class CDATASection

Node*
CDATASection::cloneNode(CCC_IN bool deep) const CCC_RAISES(DOMException)
{
  CDATASection* new_cdatasection = new CDATASection(*this);
  return new_cdatasection;
}

// CODEX
static DOMChar cdatasection_node_name[] = { 0x23 /* # */, 0x63 /* c */, 0x64 /* d */, 0x61 /* a */, 0x74 /* t */, 0x61 /* a */, 0x2d /* - */, 0x73 /* s */, 0x65 /* e */, 0x63 /* c */, 0x74 /* t */, 0x69 /* i */, 0x6f /* o */, 0x6e /* n */, 0x00, };

CDATASection::CDATASection(Document* document_, Node* parent_, CCC_IN const DOMString* value)
 : Text(document_, parent_, value)
{
  setNodeName(cdatasection_node_name);
}

CDATASection::CDATASection(Document* document_, Node* parent_, CCC_IN const DOMString& value)
 : Text(document_, parent_, &value)
{
  setNodeName(cdatasection_node_name);
}

CDATASection::CDATASection(const CDATASection& cdatasection)
 : Text(cdatasection.getOwnerDocument(), 0, &cdatasection.node_value)
{
  setNodeType(Node::CDATA_SECTION_NODE);
  setNodeName(cdatasection_node_name);
}

CDATASection::~CDATASection()
{
}
