﻿#line 1 "DOMImplementation.upp"
#include <ccc/xml/dom.h>

using namespace CCC;

DOMImplementation::DOMImplementation()
{
}

DOMImplementation::~DOMImplementation()
{
}

bool
DOMImplementation::hasFeature(CCC_IN DOMString& feature, CCC_IN DOMString& version)
{
  static DOMChar features1[] = { 0x58 /* X */, 0x4d /* M */, 0x4c /* L */, 0x00, };
  static DOMChar features2[] = { 0x48 /* H */, 0x54 /* T */, 0x4d /* M */, 0x4c /* L */, 0x00, };
  static DOMChar versions0[] = { 0x00, };
  static DOMChar versions1[] = { 0x31 /* 1 */, 0x2e /* . */, 0x30 /* 0 */, 0x00, };
  
  if (!version.strCmp(versions0) ||
      !version.strCmp(versions1))
  {
    if (!feature.strCmp(features1) ||
	!feature.strCmp(features2))
    {
      return true;
    }
  }
  return false;
}

static DOMImplementation* dom_implementation = 0;

void
DOMImplementation::initailze(bool p)
{
  if (p)
  {
    dom_implementation = new DOMImplementation();
  }
  else
  {
    delete dom_implementation;
    dom_implementation = 0;
  }
}

// CODEX
Document*
DOMImplementation::createDocument()
{
  return new Document(dom_implementation);
}

Document*
DOMImplementation::createDocument(CCC_IN const DOMString* namespace_uri,
				  CCC_IN const DOMString* qualified_name,
				  CCC_IN DocumentType* doctype) CCC_RAISES(DOMException)
{
  // TODO: DOM level 2
  return 0;
}

DocumentType*
DOMImplementation::createDocumentType(CCC_IN const DOMString* qualified_name,
				      CCC_IN const DOMString* public_id,
				      CCC_IN const DOMString* system_id) CCC_RAISES(DOMException)
{
  // TODO: DOM level 2
  return 0;
}

