﻿// $Id$

#ifndef INCLUDE_ccc_xml_XMLDecl_h
#define INCLUDE_ccc_xml_XMLDecl_h

#include <ccc/base/base.h>
#include <ccc/xml/config.h>

CCC_NAMESPACE_START(CCC);

/*!
 * (CODEX original)<br>
 * XML宣言を表現するクラスです。
 */
class XMLDecl
  : public Node
{
 public:
  /*!
   * (CODEX original)<br>
   * コンストラクタ
   */
  XMLDecl(Document* document);
  /*!
   * (CODEX original)<br>
   * デストラクタ
   */
  ~XMLDecl();
  /*!
   * (CODEX original)<br>
   * ノードを複製します。
   * \param deep deep copyするかどうかのフラグ
   * \return 複製されたノード
   */
  virtual Node* cloneNode(CCC_IN bool deep) const CCC_RAISES(DOMException);
  /*!
   * (CODEX original)<br>
   * XMLをストリームに書き出します。
   * \param xo 出力先
   */
  virtual void writeXml(XMLOutputter* xo) const CCC_RAISES(IOException);
};

CCC_NAMESPACE_END(CCC);

#endif /* INCLUDE_ccc_xml_XMLDecl_h */
