﻿// DOM
// $Id$

#ifndef INCLUDE_CCC_XML_DOM_H
#define INCLUDE_CCC_XML_DOM_H

#include <ccc/base/base.h>
#include <ccc/base/Flow.h>
#include <ccc/base/OFlow.h>
#include <ccc/base/List.h>
#include <ccc/base/LinkList.h>
#include <ccc/base/NDLinkList.h>
#include <ccc/base/AVLDict.h>
#include <ccc/base/LinkDict.h>
#include <ccc/base/LinkList.h>

#include <ccc/xml/config.h>
#include <ccc/xml/DOMString.h>

CCC_NAMESPACE_START(CCC);

/*
 * glossary	用語集
 *
 * 英語	日本語
 * ------------------------------------------------------------
 * node	ノード
 * public id	公開識別子
 * system id	システム識別子
 * namespace	名前空間
 * qualified name	修飾名
 * node name	ノード名
 * node type	ノード形式
 * node value	ノード値
 * local name	局所名
 * prefix	プリフィックス
 * atom	アトム
 */

class Attr;
class Document;
class DocumentType;
class DtdElement;
class DtdPEntity;
class Element;
class Entity;
class NamedNodeMap;
class Node;
class NodeList;
class Notation;
class ProcessingInstruction;
class NodeExtension;

CCC_NAMESPACE_END(CCC);

#include <ccc/xml/XMLOutputter.h>
#include <ccc/xml/DOMException.h>
#include <ccc/xml/DOMImplementation.h>
#include <ccc/xml/NodeAddress.h>
#include <ccc/xml/BufferPointer.h>
#include <ccc/xml/NodeList.h>
#include <ccc/xml/NNodeList.h>
#include <ccc/xml/XNodeList.h>
#include <ccc/xml/NodeExtension.h>
#include <ccc/xml/Node.h>
#include <ccc/xml/NamedNodeMap.h>
#include <ccc/xml/CharacterData.h>
#include <ccc/xml/Attr.h>
#include <ccc/xml/Element.h>
#include <ccc/xml/Text.h>
#include <ccc/xml/Comment.h>
#include <ccc/xml/CDATASection.h>
#include <ccc/xml/External.h>
#include <ccc/xml/DocumentType.h>
#include <ccc/xml/Notation.h>
#include <ccc/xml/Entity.h>
#include <ccc/xml/DtdPEntity.h>
#include <ccc/xml/DtdAttlist.h>
#include <ccc/xml/DtdECUnit.h>
#include <ccc/xml/DtdElement.h>
#include <ccc/xml/XMLDecl.h>
#include <ccc/xml/EntityReference.h>
#include <ccc/xml/ProcessingInstruction.h>
#include <ccc/xml/DocumentFragment.h>
#include <ccc/xml/AtomTable.h>
#include <ccc/xml/Document.h>
#include <ccc/xml/NodeIterator.h>
#include <ccc/xml/ConstNodeIterator.h>

#endif /* INCLUDE_CCC_XML_DOM_H */
